/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <sys/msg.h>
#include <errno.h>
#include <stdlib.h>
#include "Commun.h"
#include "../Debug.h"
#include "Initialisation_Com.h"
#include "Communication.h"


extern struct Struct_Modele_Communication Liste_Communication[];
	

gint Calculer_Ckecksum(gint *Donnee, gint Taille_Donnee){
	gint i,Ckecksum;
	
	Ckecksum = 0;
	for (i=0;i<(Taille_Donnee/sizeof(gint));i++)
		Ckecksum = Donnee[i] + Ckecksum;
		
	return Ckecksum;
}


gboolean Socket_Send_Ok(int socket){
	struct pollfd fds;
	gboolean retour;
	int polll;
	
	bzero (&fds, sizeof fds);
	fds.events = POLLOUT;
	fds.fd = socket;	


	polll = poll (&fds, 1, 1000);
	retour = (polll > 0);
	/*if (retour)
		printf("Ecriture ok  : %d\n",polll);
	else
		printf("Ecriture impossible : %d\n",polll);*/
	return retour;
}

void Communication_Envoie_Donnee (gint ID_Info, gpointer * Donnee, gint Taille_Donnee)
{

	sem_wait (&Semaphore_Communication);
	struct struct_Info_TCP Info_TCP;
	int NbOctet;
	
	Info_TCP.ID_Info = ID_Info;
	Info_TCP.Taille_Donnee = Taille_Donnee;
	Info_TCP.Ckecksum = Calculer_Ckecksum(Donnee,Taille_Donnee);
	memcpy (Info_TCP.Donnee, Donnee, Taille_Donnee);
	
	if (!Socket_Send_Ok(client_id)){
		printf("Commun.c : send (Resource temporarily unavailable)\n");
		printf("ID socket : %d\n",client_id);
		shutdown (client_id, 0);
  		close (client_id);
		exit(EXIT_SUCCESS);
	}
	
	NbOctet = send (client_id, &Info_TCP, sizeof (struct struct_Info_Entete)+Taille_Donnee, 0);
	if (NbOctet < 0)
			printf ("send  : %s\n", strerror (errno)); 


	sem_post (&Semaphore_Communication);	
	
}
