/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include "Debug.h"
#include "Com/Commun.h"
#include "Com/Initialisation_Com.h"

void debug_printf (int Niveau_Debug, const char *file, const char *Fonction, int line, char *fmt, ...)
{
	struct struct_Retour_Message Message;
	char      buffer[255];

	if (Debug >= Niveau_Debug) {
		va_list   args;

		va_start (args, fmt);
		vsnprintf (buffer, 255, fmt, args);
		switch (Niveau_Debug) {
		    case D_ERRO:
			    printf ("[A] [ERROR] [%s](%s:%d): %s\n",Fonction, file, line, buffer);
			    bzero (&Message, sizeof (struct struct_Retour_Message));
			    Message.ID_Reseau = Info_Demarrage.ID_Reseau;
			    Message.Type_message = D_ERRO;
			    strcpy (Message.File, file);
				strcpy (Message.Fonction,Fonction);
			    Message.Line = line;
			    if (strlen (buffer) >= 255)
				    buffer[255] = 0;
			    strcpy (Message.Message, buffer);
			    Communication_Envoie_Donnee (RETOUR_MESSAGE, (gpointer *) & Message, sizeof (Message));
			    exit (EXIT_FAILURE);
			    break;
		    case D_WARN_USER:
			    printf ("[A] [WARNING] [%s](%s:%d): %s\n",Fonction, file, line, buffer);
			    bzero (&Message, sizeof (struct struct_Retour_Message));
			    Message.ID_Reseau = Info_Demarrage.ID_Reseau;
			    Message.Type_message = D_WARN_USER;
			    strcpy (Message.File, file);
				strcpy (Message.Fonction,Fonction);
			    Message.Line = line;
			    if (strlen (buffer) >= 255)
				    buffer[255] = 0;
			    strcpy (Message.Message, buffer);
			    Communication_Envoie_Donnee (RETOUR_MESSAGE, (gpointer *) & Message, sizeof (Message));
			    break;
		    case D_WARN:
			    printf ("[A] [WARNING] [%s](%s:%d): %s\n",Fonction, file, line, buffer);
			    break;
		    case D_INFO_USER:
			    printf ("[A] [INFO] [%s]: %s\n",Fonction, buffer);
			    bzero (&Message, sizeof (struct struct_Retour_Message));
			    Message.ID_Reseau = Info_Demarrage.ID_Reseau;
			    Message.Type_message = D_INFO_USER;
			    strcpy (Message.File, file);
				strcpy (Message.Fonction,Fonction);
			    Message.Line = line;
			    if (strlen (buffer) >= 255)
				    buffer[255] = 0;
			    strcpy (Message.Message, buffer);
			    Communication_Envoie_Donnee (RETOUR_MESSAGE, (gpointer *) & Message, sizeof (Message));
			    break;
		    case D_INFO:
			    printf ("[A] [INFO] [%s]: %s\n",Fonction, buffer);
			    break;
		    case D_ALL:
			    printf ("[A] [ALL] [%s]:%s\n",Fonction, buffer);
			    break;
		    default:
			    printf ("[A] [?]  %s\n", buffer);
		}
		va_end (args);
		if (Niveau_Debug == D_ERRO) {
			exit (EXIT_FAILURE);
		}
	}
}


void Initialisation_Debug (void)
{
	Debug = D_WARN;
}
