/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __LISTE_EQUIPEMENT
#define         __LISTE_EQUIPEMENT

#include <glib.h>
#include <time.h>
#include <netinet/in.h>
#include "Reseau.h"

#define NB_SCAN_OS 15
#define NUM_MAX_REGISTRATION 25
#define EQUIPEMENT_UNKNOWN -1
#define EQUIPEMENT_NO_IP -2

struct struct_Reponse {
	unsigned char TaillePacketReponse;
	
	unsigned char HeaderLengthIP;
	unsigned char DSF;
	unsigned short TailleTotal;
	unsigned char Id;
	unsigned short Flags_IP_Offset;
	unsigned char TTL;
	
	unsigned char NumSeq;
	unsigned char HeaderLengthTCP;
	unsigned char Flags_TCP;
	unsigned short WindowSize;
};

struct struct_Reponse_debug{
	 
	gint      Num_Port_Utiliser;  
	time_t    Time_Debut;  
	time_t    Time_Fin;  
	gint  Temps_Reponse; 
};


struct struct_Scan_Os {
	gint      Port_Scan;
	gint      Port_Client;
	gint      Id;
	gint      Seq;
	gboolean  Reponse_Scan;
};


struct struct_Smb_Registration {
	unsigned char Type;
	unsigned char Name[16 + 1];
	unsigned char Numero;
};

struct struct_Smb {
	unsigned char HostName[16 + 1];
	unsigned char DomainName[16 + 1];
	unsigned char Utilisateur[16 + 1];
	struct struct_Smb_Registration Smb_Registration[NUM_MAX_REGISTRATION];
};


#define CHAINE_NORMALE 100
#define CHAINE_MAX 255
#define CHAINE_MINI 30	
struct Struct_Snmp {

	gchar     System_Name[CHAINE_NORMALE];
	gchar     Description[CHAINE_MAX];
	gchar     Contact[CHAINE_NORMALE];
	gchar     Location[CHAINE_NORMALE];
	gchar     Uptime[CHAINE_NORMALE];
	gint      Ram;

	gchar     Ip_Forwarding[CHAINE_MINI];
	gint      Default_TTL;
	gint      Reassembly_Timeout;
	gint      Need_To_Be_Reassembled;
	gint      Reassembled;
	gint      Reassembly_Failures;
	gint      Successfully_Fragmented;
	gint      Fragmentation_Failures;
	gint      Created_Fragments;
	gint      Discarded_Routing_Entries;

	gint      All;
	gint      Forwarded;
	gint      Delivered;
	gint      Header_Errors;
	gint      Address_Errors;
	gint      Unknown_Protocol;
	gint      Input_Buffer_Errors;

	gint      Requested;
	gint      Output_Buffer_Errors;
	gint      Not_Routed;
};


#define NB_MAX_LIGNE_LISTE_SNMP 30
struct struct_Info_Liste_Snmp {
	gint      Colonne;
	gint      Ligne;
	gchar     Info[CHAINE_NORMALE];
};

struct Struct_Liste_Equipement {
	unsigned char ID_Equipement[MAC_ADDR_LEN + IP_ADDR_LEN + 1];
	unsigned char Adresse_Ip_Char[15 + 1];
	unsigned char Adresse_Ip[4 + 1];
	unsigned char Adresse_MAC_Char[17 + 1];
	unsigned char Adresse_MAC[6 + 1];
	gboolean  Agent_AutoScan;
	gboolean  Scan_Port_En_Cours;
	gboolean  Intrus;
	gboolean  Equipement_Restaurer;
	gboolean  Equipement_Rescanner_En_Cours;
	gboolean  Equipement_Allumer;
	gboolean  Rafraichissement_Etat_En_Cours;
	time_t    Derniere_Modification_Etat_Equipement;
	gboolean  Notification_Equipement;
	gint      Compteur_Notification;
	gboolean  Alerte_Equipement_Active;
	GList    *GList_Port;
	gboolean  Scanne_Port_En_Cours;

	gboolean  Scan_Signature;
	struct struct_Reponse Reponse_Signature[NB_SCAN_OS];
	struct struct_Reponse_debug Reponse_Signature_Debug[NB_SCAN_OS];
	struct struct_Scan_Os Scan_OS[NB_SCAN_OS];
	struct struct_Smb Smb;
	gboolean  Snmp_Ouvert;
	struct Struct_Snmp Snmp;

	gboolean  GateWay;
	gboolean  Routage_Activer;
	gint      Port_Source_Test_GateWay;
	gint      Port_Destination_Test_GateWay;
	gboolean  Marquage_Change_Ip;
	
	time_t    Time_Debut;  
	time_t    Time_Fin;  
	gint  Temps_Scan_Complet; 

	time_t    Time_Debut_Resolv_DNS;  
	time_t    Time_Fin_Resolv_DNS;  
	gint  Temps_Resolv_DNS; 

	time_t    Time_Debut_Scan_Port;  
	time_t    Time_Fin_Scan_Port;  
	gint  Temps_Scan_Port; 

	time_t    Time_Debut_Scan_Signature;  
	time_t    Time_Fin_Scan_Signature;  
	gint  Temps_Scan_Signature; 

	time_t    Time_Debut_Scan_Service_Ftp;  
	time_t    Time_Fin_Scan_Service_Ftp;  
	gint  Temps_Scan_Service_Ftp; 

	time_t    Time_Debut_Scan_Service_Http;  
	time_t    Time_Fin_Scan_Service_Http;  
	gint  Temps_Scan_Service_Http; 

	time_t    Time_Debut_Scan_Service_Imap;  
	time_t    Time_Fin_Scan_Service_Imap;  
	gint  Temps_Scan_Service_Imap; 

	time_t    Time_Debut_Scan_Service_Telnet;  
	time_t    Time_Fin_Scan_Service_Telnet;  
	gint  Temps_Scan_Service_Telnet; 

	time_t    Time_Debut_Scan_Snmp;  
	time_t    Time_Fin_Scan_Snmp;  
	gint  		 Temps_Scan_Snmp; 

	time_t    Time_Debut_Samba;  
	time_t    Time_Fin_Samba;  
	gint  		 Temps_Samba; 
};

GList    *GList_Equipement;

void      Debug_ID_Equipement (unsigned char *ID_Equipement);
void      Efface_Reponse_Signature (struct Struct_Liste_Equipement *Equipement);
void      Reception_Donnee_Equipement_Connu (struct Struct_Liste_Equipement *Equipement);
void      Equipement_Arreter (struct Struct_Liste_Equipement *Equipement);
void      Affiche_Debug_Liste_Equipement (void);
struct Struct_Liste_Equipement *Retour_Pointeur_Equipement (gint Index_Equipement);
gint      Recherche_Index_Equipement (unsigned char *ID_Equipement, gboolean No_ip);
struct Struct_Liste_Equipement *Ajout_Equipement (unsigned char *ID_Equipement);
void      Initialisation_Liste_Equipement (void);
struct Struct_Liste_Equipement *Recherche_MAC_Gateway (unsigned char *MAC);
#endif
