/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Reseau.h"
#include "Debug.h"
#include "Com/Initialisation_Com.h"


/*
int network_address_to_name( network_address addr, char *name )
{
	struct hostent *h;
	struct hostent result;
	char buffer[32768];
	int herrno;
	int success;

	#ifdef __osf__
		struct hostent_data hdata;
	#endif

	addr = htonl(addr);

	#if defined(linux)
		success = gethostbyaddr_r( (char*)&addr, sizeof(addr), AF_INET, &result, buffer, 32768, &h, &herrno );

	#elif defined(__osf__)
		success = gethostbyaddr_r( (const char*)&addr, sizeof(addr), AF_INET, &result, &hdata );
	#else
		h = gethostbyaddr_r( (char*)&addr, sizeof(addr), AF_INET, &result, buffer, 32768, &herrno );
	#endif

	if(h) {
		strcpy(name,result.h_name);
		return 1;
	} else {
		return 0;
	}
}

int network_name_to_address( const char *name, network_address *addr )
{
	struct hostent *h;
	struct hostent result;
	char buffer[32768];
	int herrno;
	int success;

	#ifdef linux
		success = gethostbyname_r( name, &result, buffer, 32768, &h, &herrno );
	#elif defined(__osf__)
		struct hostent_data hdata;
		success = gethostbyname_r( name, &result, &hdata );
	#else
		h = gethostbyname_r( name, &result, buffer, 32768, &herrno );
	#endif
	if(h) {
		memcpy(addr,h->h_addr,sizeof(*addr));
		*addr = ntohl(*addr);
		return 1;
	} else {
		return 0;
	}
}

*/

void Get_My_MAC (void)
{
	struct ifreq ifr;
	struct sockaddr sock;
	int       Socket;

	strcpy (sock.sa_data, Info_Demarrage.Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket_control (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	}
	ifr.ifr_addr.sa_family = AF_INET;
	sprintf (ifr.ifr_name, Info_Demarrage.Interface);
	if (ioctl (Socket, SIOCGIFHWADDR, &ifr) == -1) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	}
	memcpy (Mon_Adresse_MAC, ifr.ifr_hwaddr.sa_data, ETH_ALEN);
	if (close_control (Socket) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	}
}


void Get_My_Ip (void)
{
	struct ifreq ifr;
	struct sockaddr_in sin;
	struct sockaddr sock;
	int       Socket;

	strcpy (sock.sa_data, Info_Demarrage.Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket_control (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));

	}
	strcpy (ifr.ifr_name, Info_Demarrage.Interface);
	if (ioctl (Socket, SIOCGIFADDR, &ifr) == -1) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));

	}
	memcpy (&sin, &ifr.ifr_addr, sizeof (struct sockaddr_in));
	memcpy (Mon_Adresse_Ip, &sin.sin_addr.s_addr, IP_ADDR_LEN);
	if (close_control (Socket) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));

	}
}


unsigned short ckecksum (char *donnee, int longueur, int valeur)
{
	int       i;
	int       somme;
	int       Nombre;

	i = 0;
	somme = 0;
	while (i < longueur) {
		if (longueur == (i + 1)) {
			donnee[i + 1] = 0;
		}
		Nombre = (((donnee[i] << 8) & 0xFF00) + (donnee[i + 1] & 0xFF));
		somme = somme + Nombre;
		i = i + 2;
	}
	while ((somme >> 16) != 0) {
		somme = (somme >> 16) + (somme & 0xffff);
	}
	somme = (0xFFFF - (somme & 0xFFFF)) - valeur;
	if ((valeur != 0) && (somme < 0))
		somme--;
	return (unsigned short) somme;
}


int waiting_service (int sock, int event)
{
	struct pollfd fds;
	int       resultat;

	bzero (&fds, sizeof fds);
	fds.events = event;
	fds.fd = sock;	
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service : (%d)", sock);
	if ((resultat = poll (&fds, 1, 1000)) > 0) {
		if ((fds.revents & POLLERR) == POLLERR) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service Socket error : (%d)", sock);
			return ERREUR_SOCK;
		}
		if ((fds.revents & POLLHUP) == POLLHUP) {
			debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service Socket error : (%d)", sock);
			return ERREUR_SOCK;
		}
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service : (%d) pret", sock);
		return DONNEE_PRET;
	}
	else {
		if (resultat != 0) {
			debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
		}
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service : (%d) Attendre", sock);
		return ATTENDRE;
	}
}


gboolean attendre_Donnee (int sock, int temp)
{
	int       result;

	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Attendre_donnee  sock:(%d)", sock);
	while ((result = waiting_service (sock, POLLIN)) == ATTENDRE) {
		debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, ".(%d)", temp);
		temp--;
		if (temp == 0) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Timeout dans Attendre_donnee");
			return FALSE;
		}
	}
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Attendre_donnee");
	if (result == ERREUR_SOCK) {
		debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Attendre_donnee (%d )Socket error : (%d)", temp, sock);
		return FALSE;
	}
	return TRUE;
}


gboolean attendre_Sock (int sock)
{
	int       temp;
	int       result;

	if (Info_Demarrage.Normal_Mode)
		temp = 40;
	else
		temp = 10;
	while ((result = waiting_service (sock, POLLOUT)) == ATTENDRE) {
	
	
		temp--;
		if (temp == 0) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Timeout dans Attendre_donnee");
			return FALSE;
		}
	}
	if (result == ERREUR_SOCK)
		return FALSE;
	return TRUE;
}


void set_NonBlock (int sock)
{
	int       flags;

	if ((flags = fcntl (sock, F_GETFL)) == -1)
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
	if (fcntl (sock, F_SETFL, flags | O_NONBLOCK) == -1)
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
}


gboolean connection_Serveur (unsigned char *Ip, int Port, int sock)
{
	struct sockaddr_in SocketAddr;

    ERROR_if ( Ip == NULL);
	memset (&SocketAddr, 0, sizeof (struct sockaddr_in));



	
	if (inet_aton(Ip,&SocketAddr.sin_addr)==0)
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "inet_aton()");
	

	SocketAddr.sin_family = AF_INET;
	SocketAddr.sin_port = htons (Port);
	if (connect (sock, (struct sockaddr *) &SocketAddr, sizeof (struct sockaddr)) < 0) {
		if (errno != EINPROGRESS) {
		
		
		
			debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s : Equipement : [%s] port:[%d] ", strerror (errno), Ip, Port);
			return FALSE;
		}
		if (attendre_Sock (sock) == FALSE) {
			return FALSE;
		}
	}
	return TRUE;	
}


unsigned char *resoudre_DNS (char *Serveur,unsigned char *Adresse_Ip)
{
	int       ret, err;
	char     *ptr;
	char      buf[1024];
	struct hostent h, *host, *hostent;
	struct sockaddr_in SocketAddr;
	
	ERROR_if ( Serveur == NULL);
	sem_wait (&Semaphore_GetHostByName);
	ret = gethostbyname_r (Serveur, &h, buf, sizeof (buf), &host, &err);
	if (host == NULL) {
		switch (err) {
		    case HOST_NOT_FOUND:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "L'hôte indiqué est inconnu. [%s]", Serveur);
			    break;
		    case NO_ADDRESS:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Le nom est valide mais ne possède pas d'adresse IP. [%s]", Serveur);
			    break;
		    case NO_RECOVERY:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Une erreur fatale du serveur de noms est apparue. [%s]", Serveur);
			    break;
		    case TRY_AGAIN:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Aucune connection Ã  internet. [%s]", Serveur);
			    break;
		    default:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur Inconnue [%s]", Serveur);
			    break;
		}
		sem_post (&Semaphore_GetHostByName);
		return NULL;
	}
	printf ("resoudre_DNS : Nom Officiel : %s  taille : %d \n", host->h_name, host->h_length);
	memset (&SocketAddr, 0, sizeof (struct sockaddr_in));
	memcpy (&SocketAddr.sin_addr.s_addr, host->h_addr, host->h_length);
	strcpy (Adresse_Ip, inet_ntoa (SocketAddr.sin_addr));
	printf("Adresse resolu : %s\n",Adresse_Ip);
	sem_post (&Semaphore_GetHostByName);
	return Adresse_Ip;
}


int Creation_Socket_TCP (void)
{
	int       sock;

	sock = socket_control (AF_INET, SOCK_STREAM, 0);
	if (sock == -1)
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Creation d'une socket TCP/IP");
	return sock;
}


int ConnectionServeur (unsigned char *Ip, char *Serveur, int Port, int Tentative)
{
	int       IdSocket;
	gboolean  Connection_Accepter;
	unsigned char *Adresse_Ip_Utiliser,Adresse_Ip_Resolu[15 + 1];

	ERROR_if ( (Serveur == NULL)&&(Ip == NULL));

	if (Ip == NULL) {
	  if ((Adresse_Ip_Utiliser = resoudre_DNS (Serveur,Adresse_Ip_Resolu)) == NULL) 
		return (-1);
  }
  else
	  Adresse_Ip_Utiliser =Ip;

	IdSocket = Creation_Socket_TCP ();
	set_NonBlock (IdSocket);
	Connection_Accepter = FALSE;
	do {
	
		if (connection_Serveur (Adresse_Ip_Utiliser, Port, IdSocket) == FALSE) {
			if (Tentative != 1)
				sleep (5);
		}
		else
			Connection_Accepter = TRUE;
		Tentative--;
	} while ((!Connection_Accepter) && (Tentative != 0));

	if (!Connection_Accepter) {
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Impossible de se connecter");
		if (close_control (IdSocket) < 0)
			debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
		return -1;
	}
	return IdSocket;
}


gint create_tcp_server (int Port, int Nb_Max_Client)
{
	int       Socket, optval;
	struct sockaddr_in SocketAddr;


	if (-1 == (Socket = socket (PF_INET, SOCK_STREAM, 0)))
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));

	optval = 1;
	setsockopt (Socket, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof (int));

	memset ((char *) &SocketAddr, 0, sizeof (struct sockaddr_in));
	SocketAddr.sin_family = AF_INET;
	SocketAddr.sin_port = htons (Port);
	SocketAddr.sin_addr.s_addr = htonl (INADDR_ANY);
	if (-1 == (bind (Socket, (struct sockaddr *) &SocketAddr, sizeof (struct sockaddr_in))))
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));

	if (-1 == (listen (Socket, Nb_Max_Client)))
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
	return (Socket);
}
