/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Scan_Equipement.h"
#include "Debug.h"
#include "Scan_Port.h"
#include "Scan_Signature.h"
#include "Scan_Netbios.h"
#include "Thread.h"
#include "Scan_Service.h"
#include "Com/Commun.h"
#include "Com/Communication.h"
#include "Com/Initialisation_Com.h"
#include "Semaphore.h"
#include "Snmp.h"
#include "Scan_Arp.h"


void Rescanne_Equipement (struct Struct_Liste_Equipement *Equipement)
{
	struct Struct_Port *Port_Equipement = NULL;
	gchar    *banniere = NULL;
	struct struct_Retour_Rachaichir_Etat_Equipement Message_Etat;
	struct struct_Retour_Rafraichir_Equipement Message;
	gint      i,Nb_Port_Ajouter_Ouvert, Nb_Port_Ajouter_Fermer, Nb_Port_Ajouter_Firewalled , Tentative_NetBios,Tentative_NetBios_MAX;
	gboolean  Sauve_Etat;

	debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Equipment Rescanne : [%s]",Equipement->Adresse_Ip_Char);
	Sauve_Etat = Equipement->Equipement_Allumer;
	Equipement->Rafraichissement_Etat_En_Cours = TRUE;
	Equipement->Compteur_Notification = 0;
	Equipement->Equipement_Allumer = FALSE;
	Envoie_Arp_Equipement (Equipement, 4);
	sleep (2);
	Equipement->Rafraichissement_Etat_En_Cours = FALSE;

	
	bzero (&Message, sizeof (struct struct_Retour_Rafraichir_Equipement));
	Message.ID_Reseau = Info_Demarrage.ID_Reseau;
	memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
	if (Sauve_Etat != Equipement->Equipement_Allumer) {
		bzero (&Message_Etat, sizeof (struct struct_Retour_Rachaichir_Etat_Equipement));
		Message_Etat.ID_Reseau = Info_Demarrage.ID_Reseau;
		memcpy (Message_Etat.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message_Etat.Equipement_Allumer = Equipement->Equipement_Allumer;
		Message_Etat.Derniere_Modification_Etat_Equipement = Equipement->Derniere_Modification_Etat_Equipement;
		Communication_Envoie_Donnee (RETOUR_RAFRAICHIR_ETAT_EQUIMEMENT, (gpointer *) & Message_Etat, sizeof (Message_Etat));
	}
	if (!Equipement->Equipement_Allumer) {
		debug_printf (D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Equipment : DOWN");
		Message.Scan_Accompli = FALSE;
		Communication_Envoie_Donnee (RETOUR_RAFRAICHIR_EQUIPEMENT, (gpointer *) & Message, sizeof (Message));
		pthread_exit (NULL);
	}
	Equipement->Scan_Port_En_Cours = TRUE;

	Equipement->Time_Debut = time(NULL);
	

	
	Equipement->Time_Debut_Resolv_DNS = time(NULL);
	Recupere_Nom_DNS (Equipement->Adresse_Ip_Char, Message.Nom_DNS);
	Equipement->Time_Fin_Resolv_DNS = time(NULL);
	Equipement->Temps_Resolv_DNS = (gint) difftime(Equipement->Time_Fin_Resolv_DNS, Equipement->Time_Debut_Resolv_DNS);
	Message.Temps_Resolv_DNS = Equipement->Temps_Resolv_DNS;
	

	
	
	Equipement->Time_Debut_Scan_Port = time(NULL);
	Scanne_Toutes_Les_Ports (Equipement);
	Equipement->Time_Fin_Scan_Port = time(NULL);
	Equipement->Temps_Scan_Port = (gint) difftime(Equipement->Time_Fin_Scan_Port, Equipement->Time_Debut_Scan_Port);
	Message.Temps_Scan_Port = Equipement->Temps_Scan_Port;
	
	
		

	i = 0;
	Message.Nb_Port_Total_Scanner  = g_list_length (Equipement->GList_Port);

	Message.Nb_Port_Ouvert = 0;
	Message.Nb_Port_Fermer = 0;
	Message.Nb_Port_Firewaller = 0;
	Nb_Port_Ajouter_Ouvert = 0;
	Nb_Port_Ajouter_Fermer = 0;
	Nb_Port_Ajouter_Firewalled = 0;
	while (i < Message.Nb_Port_Total_Scanner)  {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
	
		if ((Port_Equipement->Etat_Port == OUVERT) || (Port_Equipement->Notification)) {
			if (Nb_Port_Ajouter_Ouvert<MAX_PORTS){
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter port %d dans la liste", Port_Equipement->Num_Port);
				Message.Port_Ouvert[Nb_Port_Ajouter_Ouvert].Num_Port = Port_Equipement->Num_Port;
				Message.Port_Ouvert[Nb_Port_Ajouter_Ouvert].Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
				Message.Port_Ouvert[Nb_Port_Ajouter_Ouvert].Etat_Port = Port_Equipement->Etat_Port;
				Message.Port_Ouvert[Nb_Port_Ajouter_Ouvert].Notification_Active = Port_Equipement->Notification;
				Nb_Port_Ajouter_Ouvert++;
			}
			if (Port_Equipement->Etat_Port == OUVERT)
				Message.Nb_Port_Ouvert++;
		}
	
		if  (Port_Equipement->Etat_Port == FERMER) {
			if (Nb_Port_Ajouter_Fermer<MAX_PORTS){
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter port fermer %d dans la liste", Port_Equipement->Num_Port);
				Message.Port_Fermer[Nb_Port_Ajouter_Fermer].Num_Port = Port_Equipement->Num_Port;
				Message.Port_Fermer[Nb_Port_Ajouter_Fermer].Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
				Nb_Port_Ajouter_Fermer++;
			}
			Message.Nb_Port_Fermer++;
		}
	
		if (Port_Equipement->Etat_Port == FIREWALLED) {
			if (Nb_Port_Ajouter_Firewalled<MAX_PORTS){
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter port firewaller %d dans la liste", Port_Equipement->Num_Port);
				Message.Port_Firewalled[Nb_Port_Ajouter_Firewalled].Num_Port = Port_Equipement->Num_Port;
				Message.Port_Firewalled[Nb_Port_Ajouter_Firewalled].Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
				Nb_Port_Ajouter_Firewalled++;
			}
			Message.Nb_Port_Firewaller++;
		}
		i++;
	}
	
	
	
	if (memcmp (Equipement->ID_Equipement, Mon_Adresse_MAC, MAC_ADDR_LEN) != 0) {
	
		Equipement->GateWay = FALSE;
		Equipement->Routage_Activer = FALSE;
		Message.Port_Signature_Ouvert = Cherche_Un_Port_Avec_Etat (Equipement, OUVERT);
		Message.Port_Signature_Fermer = Cherche_Un_Port_Avec_Etat (Equipement, FERMER);
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Scan os (%s) avec comme num port ouvert[%d]   num port fermer[%d]", Equipement->Adresse_Ip_Char,Message.Port_Signature_Ouvert,Message.Port_Signature_Fermer);

		Equipement->Time_Debut_Scan_Signature = time(NULL);
		if ((Message.Port_Signature_Ouvert != -1) || (Message.Port_Signature_Fermer!= -1))
			Envoie_Trames_Scanne_Os (Equipement, Message.Port_Signature_Ouvert, Message.Port_Signature_Fermer);
		Equipement->Time_Fin_Scan_Signature = time(NULL);
		Equipement->Temps_Scan_Signature = (gint) difftime(Equipement->Time_Fin_Scan_Signature, Equipement->Time_Debut_Scan_Signature);
		Message.Temps_Scan_Signature = Equipement->Temps_Scan_Signature;
					
	
		memcpy (Message.Reponse_Signature, Equipement->Reponse_Signature, sizeof (struct struct_Reponse) * NB_SCAN_OS);
		memcpy (Message.Reponse_Signature_Debug, Equipement->Reponse_Signature_Debug, sizeof (struct struct_Reponse_debug) * NB_SCAN_OS);

	
		Message.GateWay = Equipement->GateWay;
	
		Message.Routage = Equipement->Routage_Activer;
		
		
		
		

		if (Cherche_Si_Port_Ouvert (Equipement, PORT_FTP)) {
			Equipement->Time_Debut_Scan_Service_Ftp = time(NULL);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port FTP ouvert");
			banniere = Recupere_Banniere_FTP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_FTP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_FTP, banniere);
				else {
					strncpy (Message.Entete_FTP, banniere, 499);
					Message.Entete_FTP[499] = '\0';
				}
				g_free (banniere);
			}
			Equipement->Time_Fin_Scan_Service_Ftp = time(NULL);
			Equipement->Temps_Scan_Service_Ftp = (gint) difftime(Equipement->Time_Fin_Scan_Service_Ftp, Equipement->Time_Debut_Scan_Service_Ftp);
			Message.Temps_Scan_Service_Ftp = Equipement->Temps_Scan_Service_Ftp;
		}
		else
			Message.Temps_Scan_Service_Ftp = -1;

		

		if (Cherche_Si_Port_Ouvert (Equipement, PORT_HTTP)) {
			Equipement->Time_Debut_Scan_Service_Http = time(NULL);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port HTTP ouvert");
			banniere = Recupere_Banniere_HTTP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_HTTP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_HTTP, banniere);
				else {
					strncpy (Message.Entete_HTTP, banniere, 499);
					Message.Entete_HTTP[499] = '\0';
				}
				g_free (banniere);
			}
			Equipement->Time_Fin_Scan_Service_Http = time(NULL);
			Equipement->Temps_Scan_Service_Http = (gint) difftime(Equipement->Time_Fin_Scan_Service_Http, Equipement->Time_Debut_Scan_Service_Http);
			Message.Temps_Scan_Service_Http = Equipement->Temps_Scan_Service_Http;
		}
		else
			Message.Temps_Scan_Service_Http = -1;
		
		

				
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_IMAP)) {
			Equipement->Time_Debut_Scan_Service_Imap = time(NULL);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port IMAP ouvert");
			banniere = Recupere_Banniere_IMAP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_IMAP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_IMAP, banniere);
				else {
					strncpy (Message.Entete_IMAP, banniere, 499);
					Message.Entete_IMAP[499] = '\0';
				}
				g_free (banniere);
			}
			Equipement->Time_Fin_Scan_Service_Imap = time(NULL);
			Equipement->Temps_Scan_Service_Imap = (gint) difftime(Equipement->Time_Fin_Scan_Service_Imap, Equipement->Time_Debut_Scan_Service_Imap);
			Message.Temps_Scan_Service_Imap = Equipement->Temps_Scan_Service_Imap;
		}
		else
			Message.Temps_Scan_Service_Imap = -1;

		
		
		
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_TELNET)) {
			Equipement->Time_Debut_Scan_Service_Telnet = time(NULL);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port TELNET ouvert");
			banniere = Recupere_Banniere_TELNET (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_TELNET, "");
			}
			else {
				if (strlen (banniere) < 999)
					strcpy (Message.Entete_TELNET, banniere);
				else {
					strncpy (Message.Entete_TELNET, banniere, 999);
					Message.Entete_TELNET[999] = '\0';
				}
				g_free (banniere);
			}
			Equipement->Time_Fin_Scan_Service_Telnet = time(NULL);
			Equipement->Temps_Scan_Service_Telnet = (gint) difftime(Equipement->Time_Fin_Scan_Service_Telnet, Equipement->Time_Debut_Scan_Service_Telnet);
			Message.Temps_Scan_Service_Telnet = Equipement->Temps_Scan_Service_Telnet;
		}
		else
			Message.Temps_Scan_Service_Telnet = -1;
	}

	
	
	if (Cherche_Si_Port_Ouvert (Equipement, PORT_NETBIOS)) {
		Equipement->Time_Debut_Samba = time(NULL);
		Tentative_NetBios = 0;
		if (Info_Demarrage.Normal_Mode)
			Tentative_NetBios_MAX = 5;
		else
			Tentative_NetBios_MAX = 2;
		while ((Tentative_NetBios < Tentative_NetBios_MAX) && (!Demande_NetBios (Equipement, Tentative_NetBios))) {
			Tentative_NetBios++;
			sleep (1);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Nouvelle tentative NETBIOS tentatice(%d) (%s)", Tentative_NetBios, Equipement->Adresse_Ip_Char);
		}
		memcpy (&Message.Smb, &Equipement->Smb, sizeof (struct struct_Smb)); 
		Equipement->Time_Fin_Samba = time(NULL);
		Equipement->Temps_Samba = (gint) difftime(Equipement->Time_Fin_Samba, Equipement->Time_Debut_Samba);
		Message.Temps_Samba = Equipement->Temps_Samba;
	}
	

	
	
	
	
	
	

	Equipement->Time_Fin = time(NULL);
	Equipement->Temps_Scan_Complet = (gint) difftime(Equipement->Time_Fin, Equipement->Time_Debut);
	Message.Temps_Scan_Complet = Equipement->Temps_Scan_Complet;
	
	printf("Rescan %s Total : %d - ResolvDNS :%d - ScanPort :%d - ScanSignature :%d - Ftp : %d - http:%d - imap:%d - telnet:%d - samba:%d - snmp:%d\n",Equipement->Adresse_Ip_Char,Message.Temps_Scan_Complet,	Message.Temps_Resolv_DNS,	Message.Temps_Scan_Port,	Message.Temps_Scan_Signature,Message.Temps_Scan_Service_Ftp,Message.Temps_Scan_Service_Http,Message.Temps_Scan_Service_Imap,Message.Temps_Scan_Service_Telnet,Message.Temps_Samba,Message.Temps_Scan_Snmp);

	

	Message.Scan_Accompli = TRUE;
	Communication_Envoie_Donnee (RETOUR_RAFRAICHIR_EQUIPEMENT, (gpointer *) & Message, sizeof (Message));
	Equipement->Scan_Signature = FALSE;
	Equipement->Scan_Port_En_Cours = FALSE;
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Fin Rescanne_Equipement");
	pthread_exit (NULL);
}


void Demande_Rafraichir_Equipement (gpointer * Donnee)
{
	struct struct_Demande_Rachaichir_Etat_Equipement *Message = (struct struct_Demande_Rachaichir_Etat_Equipement *) Donnee;
	struct Struct_Liste_Equipement *Equipement = NULL;
	gint      ID_Equipement;

	ERROR_if (Donnee == NULL);
	ID_Equipement = Recherche_Index_Equipement (Message->ID_Equipement,TRUE);
	if (ID_Equipement == EQUIPEMENT_UNKNOWN) {
		debug_printf (D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Refresh (Equipment unknown)");
		return;	
	}
	if (ID_Equipement == EQUIPEMENT_NO_IP) {
		debug_printf (D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Refresh (no IP)");
		return;	
	}
	Equipement = Retour_Pointeur_Equipement (ID_Equipement);

	demmarrage_Thread (&Rescanne_Equipement, (gpointer *) Equipement);
}



void Scanne_Equipement (struct Struct_Liste_Equipement *Equipement)
{
	struct Struct_Port *Port_Equipement = NULL;
	gchar    *banniere = NULL;
	struct struct_Nouveau_Equipement Message;
	gint      i, Nb_Port_Ajouter_Ouvert, Nb_Port_Ajouter_Fermer, Nb_Port_Ajouter_Firewalled, Tentative_NetBios,Tentative_NetBios_MAX;

	ERROR_if (Equipement == NULL);

	Equipement->Time_Debut = time(NULL);

	bzero (&Message, sizeof (struct struct_Nouveau_Equipement));	

	Message.ID_Reseau = Info_Demarrage.ID_Reseau;
	memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
	memcpy (Message.Adresse_Ip_Char, Equipement->Adresse_Ip_Char, 15 + 1);
	memcpy (Message.Adresse_MAC_Char, Equipement->Adresse_MAC_Char, 17 + 1);

	Message.Intrus = Equipement->Intrus;



	
	
	
	Equipement->Time_Debut_Resolv_DNS = time(NULL);
	Recupere_Nom_DNS (Equipement->Adresse_Ip_Char, Message.Nom_DNS);
	Equipement->Time_Fin_Resolv_DNS = time(NULL);
	Equipement->Temps_Resolv_DNS = (gint) difftime(Equipement->Time_Fin_Resolv_DNS, Equipement->Time_Debut_Resolv_DNS);
	Message.Temps_Resolv_DNS = Equipement->Temps_Resolv_DNS;
	
	
	
	
	Equipement->Time_Debut_Scan_Port = time(NULL);
	Scanne_Toutes_Les_Ports (Equipement);
	Equipement->Time_Fin_Scan_Port = time(NULL);
	Equipement->Temps_Scan_Port = (gint) difftime(Equipement->Time_Fin_Scan_Port, Equipement->Time_Debut_Scan_Port);
	Message.Temps_Scan_Port = Equipement->Temps_Scan_Port;
	
	
	

	i = 0;
	Message.Nb_Port_Total_Scanner = g_list_length (Equipement->GList_Port);

	Message.Nb_Port_Ouvert = 0;
	Message.Nb_Port_Fermer = 0;
	Message.Nb_Port_Firewaller = 0;
	Nb_Port_Ajouter_Ouvert = 0;
	Nb_Port_Ajouter_Fermer = 0;
	Nb_Port_Ajouter_Firewalled = 0;
	while (i < Message.Nb_Port_Total_Scanner)  {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
	
		if (Port_Equipement->Etat_Port == OUVERT){			
			if (Nb_Port_Ajouter_Ouvert<MAX_PORTS) {
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter port %d dans la liste", Port_Equipement->Num_Port);
				Message.Port_Ouvert[Nb_Port_Ajouter_Ouvert].Num_Port = Port_Equipement->Num_Port;
				Message.Port_Ouvert[Nb_Port_Ajouter_Ouvert].Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
				Nb_Port_Ajouter_Ouvert++;
			}
			Message.Nb_Port_Ouvert++;
		}
	
		if  (Port_Equipement->Etat_Port == FERMER) {
			if (Nb_Port_Ajouter_Fermer<MAX_PORTS){
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter port fermer %d dans la liste", Port_Equipement->Num_Port);
				Message.Port_Fermer[Nb_Port_Ajouter_Fermer].Num_Port = Port_Equipement->Num_Port;
				Message.Port_Fermer[Nb_Port_Ajouter_Fermer].Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
				Nb_Port_Ajouter_Fermer++;
			}
			Message.Nb_Port_Fermer++;
		}
	
		if (Port_Equipement->Etat_Port == FIREWALLED) {
			if (Nb_Port_Ajouter_Firewalled<MAX_PORTS){
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter port firewaller %d dans la liste", Port_Equipement->Num_Port);
				Message.Port_Firewalled[Nb_Port_Ajouter_Firewalled].Num_Port = Port_Equipement->Num_Port;
				Message.Port_Firewalled[Nb_Port_Ajouter_Firewalled].Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
				Nb_Port_Ajouter_Firewalled++;
			}
			Message.Nb_Port_Firewaller++;
		}
		i++;
	}
	
	
	
	if (memcmp (Equipement->ID_Equipement, Mon_Adresse_MAC, MAC_ADDR_LEN) != 0) {
		Equipement->Agent_AutoScan = FALSE;
		Message.Agent_AutoScan = FALSE;
		Message.Port_Signature_Ouvert = Cherche_Un_Port_Avec_Etat (Equipement, OUVERT);
		Message.Port_Signature_Fermer = Cherche_Un_Port_Avec_Etat (Equipement, FERMER);
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Scan os (%s) avec comme num port ouvert[%d]   num port fermer[%d]", Equipement->Adresse_Ip_Char,Message.Port_Signature_Ouvert,Message.Port_Signature_Fermer);

		
		Equipement->Time_Debut_Scan_Signature = time(NULL);
		if ((Message.Port_Signature_Ouvert != -1) || (Message.Port_Signature_Fermer!= -1))
			Envoie_Trames_Scanne_Os (Equipement, Message.Port_Signature_Ouvert, Message.Port_Signature_Fermer);
		Equipement->Time_Fin_Scan_Signature = time(NULL);
		Equipement->Temps_Scan_Signature = (gint) difftime(Equipement->Time_Fin_Scan_Signature, Equipement->Time_Debut_Scan_Signature);
		Message.Temps_Scan_Signature = Equipement->Temps_Scan_Signature;
		
		
	
		memcpy (Message.Reponse_Signature, Equipement->Reponse_Signature, sizeof (struct struct_Reponse) * NB_SCAN_OS);
		memcpy (Message.Reponse_Signature_Debug, Equipement->Reponse_Signature_Debug, sizeof (struct struct_Reponse_debug) * NB_SCAN_OS);
	
		Message.GateWay = Equipement->GateWay;
	
		Message.Routage = Equipement->Routage_Activer;
		

		if (Cherche_Si_Port_Ouvert (Equipement, PORT_FTP)) {
			Equipement->Time_Debut_Scan_Service_Ftp = time(NULL);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port FTP ouvert");
			banniere = Recupere_Banniere_FTP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_FTP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_FTP, banniere);
				else {
					strncpy (Message.Entete_FTP, banniere, 499);
					Message.Entete_FTP[499] = '\0';
				}
				g_free (banniere);
			}
			Equipement->Time_Fin_Scan_Service_Ftp = time(NULL);
			Equipement->Temps_Scan_Service_Ftp = (gint) difftime(Equipement->Time_Fin_Scan_Service_Ftp, Equipement->Time_Debut_Scan_Service_Ftp);
			Message.Temps_Scan_Service_Ftp = Equipement->Temps_Scan_Service_Ftp;
		}
		else
			Message.Temps_Scan_Service_Ftp = -1;
		
		
	

		if (Cherche_Si_Port_Ouvert (Equipement, PORT_HTTP)) {
			Equipement->Time_Debut_Scan_Service_Http = time(NULL);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port HTTP ouvert");
			banniere = Recupere_Banniere_HTTP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_HTTP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_HTTP, banniere);
				else {
					strncpy (Message.Entete_HTTP, banniere, 499);
					Message.Entete_HTTP[499] = '\0';
				}
				g_free (banniere);
			}
			Equipement->Time_Fin_Scan_Service_Http = time(NULL);
			Equipement->Temps_Scan_Service_Http = (gint) difftime(Equipement->Time_Fin_Scan_Service_Http, Equipement->Time_Debut_Scan_Service_Http);
			Message.Temps_Scan_Service_Http = Equipement->Temps_Scan_Service_Http;
		}
		else
			Message.Temps_Scan_Service_Http = -1;
		
		
		

		if (Cherche_Si_Port_Ouvert (Equipement, PORT_IMAP)) {
			Equipement->Time_Debut_Scan_Service_Imap = time(NULL);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port IMAP ouvert");
			banniere = Recupere_Banniere_IMAP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_IMAP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_IMAP, banniere);
				else {
					strncpy (Message.Entete_IMAP, banniere, 499);
					Message.Entete_IMAP[499] = '\0';
				}
				g_free (banniere);
			}
			Equipement->Time_Fin_Scan_Service_Imap = time(NULL);
			Equipement->Temps_Scan_Service_Imap = (gint) difftime(Equipement->Time_Fin_Scan_Service_Imap, Equipement->Time_Debut_Scan_Service_Imap);
			Message.Temps_Scan_Service_Imap = Equipement->Temps_Scan_Service_Imap;
		}
		else
			Message.Temps_Scan_Service_Imap = -1;

		
		
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_TELNET)) {
			Equipement->Time_Debut_Scan_Service_Telnet = time(NULL);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port TELNET ouvert");
			banniere = Recupere_Banniere_TELNET (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_TELNET, "");
			}
			else {
				if (strlen (banniere) < 999)
					strcpy (Message.Entete_TELNET, banniere);
				else {
					strncpy (Message.Entete_TELNET, banniere, 999);
					Message.Entete_TELNET[999] = '\0';
				}
				g_free (banniere);
			}
			Equipement->Time_Fin_Scan_Service_Telnet = time(NULL);
			Equipement->Temps_Scan_Service_Telnet = (gint) difftime(Equipement->Time_Fin_Scan_Service_Telnet, Equipement->Time_Debut_Scan_Service_Telnet);
			Message.Temps_Scan_Service_Telnet = Equipement->Temps_Scan_Service_Telnet;
		}
		else
			Message.Temps_Scan_Service_Telnet = -1;
		
	}
	else {
		Equipement->Agent_AutoScan = TRUE;
		Message.Agent_AutoScan = TRUE;
	}

	
	if (Cherche_Si_Port_Ouvert (Equipement, PORT_NETBIOS)) {
		Equipement->Time_Debut_Samba = time(NULL);
		Tentative_NetBios = 0;
		if (Info_Demarrage.Normal_Mode)
			Tentative_NetBios_MAX = 5;
		else
			Tentative_NetBios_MAX = 2;
		while ((Tentative_NetBios < Tentative_NetBios_MAX) && (!Demande_NetBios (Equipement, Tentative_NetBios))) {
			Tentative_NetBios++;
			sleep (1);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Nouvelle tentative NETBIOS tentatice(%d) (%s)", Tentative_NetBios, Equipement->Adresse_Ip_Char);
		}
		memcpy (&Message.Smb, &Equipement->Smb, sizeof (struct struct_Smb)); 
		Equipement->Time_Fin_Samba = time(NULL);
		Equipement->Temps_Samba = (gint) difftime(Equipement->Time_Fin_Samba, Equipement->Time_Debut_Samba);
		Message.Temps_Samba = Equipement->Temps_Samba;
	}
	
	
	
	
#ifdef        __SNMP_ENABLE
	Equipement->Time_Debut_Scan_Snmp = time(NULL);
	Demande_Snmp_Equipement (Equipement);
	Equipement->Time_Fin_Scan_Snmp = time(NULL);
	Equipement->Temps_Scan_Snmp = (gint) difftime(Equipement->Time_Fin_Scan_Snmp, Equipement->Time_Debut_Scan_Snmp);
	Message.Temps_Scan_Snmp = Equipement->Temps_Scan_Snmp;
	Message.Snmp_Ouvert = Equipement->Snmp_Ouvert;
	memcpy (&Message.Snmp, &Equipement->Snmp, sizeof (struct Struct_Snmp));
#endif

	

	Equipement->Time_Fin = time(NULL);
	Equipement->Temps_Scan_Complet = (gint) difftime(Equipement->Time_Fin, Equipement->Time_Debut);
	Message.Temps_Scan_Complet = Equipement->Temps_Scan_Complet;
	
	


	
	
	
	
	Communication_Envoie_Donnee (NOUVEAU_EQUIPEMENT, (gpointer *) & Message, sizeof (Message));
	Equipement->Scan_Signature = FALSE;

	
	
	
#ifdef        __SNMP_ENABLE
	if (Equipement->Snmp_Ouvert) {
		for (i = 0; i < NB_ID_SNMP_LISTE; i++)
			Envoie_Snmp_Liste (Equipement, i);
	};
#endif
	
	

	sem_post (&Semaphore_Thread_Scan);
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Fin thread Scan equipement");
	pthread_exit (NULL);
}
