/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Scan_Netbios.h"
#include "Debug.h"
#include "Info.h"
#include "Reseau.h"

char      nbtname[] = { 0x80, 0xf0, 0x00, 0x10, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x43, 0x4b, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x00, 0x00, 0x21, 0x00, 0x01 };

gboolean waiting_donnee (int sock, int pause)
{
	struct pollfd fds;
	int       resultat;

	bzero (&fds, sizeof fds);
	fds.events = POLLIN;
	fds.fd = sock;	
	if ((resultat = poll (&fds, 1, pause)) > 0) {
		if ((fds.revents & POLLERR) == POLLERR) {
			debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Condition d'erreur");
			return FALSE;
		}
		if ((fds.revents & POLLHUP) == POLLHUP) {
			debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Déconnexion");
			return FALSE;
		}
		return TRUE;
	}
	else {
		if (resultat != 0)
			debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
		return FALSE;
	}
}


gboolean Demande_NetBios (struct Struct_Liste_Equipement * Equipement, gint Tentative)
{


	int       Socket, i, j, octet_recu;
	struct sockaddr_in server;
	unsigned char buf[255], *FinChaine;

	ERROR_if (Equipement == NULL);

	if ((Socket = socket_control (PF_INET, SOCK_DGRAM, UDP)) < 0)
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));

	bzero (&Equipement->Smb, sizeof (struct struct_Smb));



	bzero ((char *) &server, sizeof (struct sockaddr_in));
	if (inet_aton(Equipement->Adresse_Ip_Char,&server.sin_addr)==0)
			debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "inet_aton()");
	server.sin_family = AF_INET;
	server.sin_port = htons (NETBIOS);
	Nouveau_Octet_Envoye (sizeof (nbtname));
	if (sendto (Socket, nbtname, sizeof (nbtname), 0, (struct sockaddr *) &server, sizeof (server)) < 0) {
		if ((errno != EPIPE) && (errno != ESPIPE))
			debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
	}
	else {
		set_NonBlock (Socket);
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Demande NETBIOS tentative (%d)[%s]", Tentative, Equipement->Adresse_Ip_Char);
		if (waiting_donnee (Socket, 3000)) {
			octet_recu = read (Socket, buf, sizeof (buf) - 1);
			Nouveau_Octet_Recu (octet_recu);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Nombre d'enregistrement NetBios (%d)[%s]", buf[56], Equipement->Adresse_Ip_Char);
			if (buf[56] == 0) {
				if (close_control (Socket) < 0)
					debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
				return TRUE;
			}
			for (i = 0; i < buf[56]; i++) {
				strncpy (Equipement->Smb.Smb_Registration[i].Name, &buf[57 + (i * 18)], 15);
				Equipement->Smb.Smb_Registration[i].Name[15] = 0;
				j = 14;
				while ((j != 0) && (Equipement->Smb.Smb_Registration[i].Name[j] == 0x20)) {
					Equipement->Smb.Smb_Registration[i].Name[j] = 0;
					j--;
				}
				for (j = 0; j < strlen (Equipement->Smb.Smb_Registration[i].Name); j++)
					if (Equipement->Smb.Smb_Registration[i].Name[j] < 31 || Equipement->Smb.Smb_Registration[i].Name[j] > 126)
						Equipement->Smb.Smb_Registration[i].Name[j] = '_';

			
			
			
			
			
				Equipement->Smb.Smb_Registration[i].Numero = buf[57 + 15 + (i * 18)];
			
				if (buf[57 + 15 + 1 + (i * 18)] & 128) {
					Equipement->Smb.Smb_Registration[i].Type = REGISTRATION_GROUP;
					debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "GROUP %s <%02X>\n", Equipement->Adresse_Ip_Char, Equipement->Smb.Smb_Registration[i].Name, Equipement->Smb.Smb_Registration[i].Numero);
				}
				else {
					Equipement->Smb.Smb_Registration[i].Type = REGISTRATION_UNIQUE;
					debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "UNIQUE   %s <%02X>\n", Equipement->Adresse_Ip_Char, Equipement->Smb.Smb_Registration[i].Name, Equipement->Smb.Smb_Registration[i].Numero);
				}
				if ((Equipement->Smb.Smb_Registration[i].Numero == 0x20) && (Equipement->Smb.Smb_Registration[i].Type = REGISTRATION_UNIQUE))
					strcpy (Equipement->Smb.HostName, Equipement->Smb.Smb_Registration[i].Name);
			
				if ((Equipement->Smb.Smb_Registration[i].Numero == 0x00) && (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_GROUP))
					strcpy (Equipement->Smb.DomainName, Equipement->Smb.Smb_Registration[i].Name);
			
				if ((Equipement->Smb.Smb_Registration[i].Numero == 0x03) && (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE))
					strcpy (Equipement->Smb.Utilisateur, Equipement->Smb.Smb_Registration[i].Name);
			}
		}
		else {
			if (close_control (Socket) < 0)
				debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Aucune reponse NETBIOS tentatice(%d) (%s)", Tentative, Equipement->Adresse_Ip_Char);
			return FALSE;
		}
	}
	if (close_control (Socket) < 0)
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	return TRUE;
}
