/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifdef        __SNMP_ENABLE

#include "Snmp.h"
#include "Debug.h"
#include "Com/Commun.h"
#include "Com/Communication.h"
#include "Com/Initialisation_Com.h"
#include "Semaphore.h"

struct Struct_Liste_Snmp Liste_Snmp[] = {
	{SNMP_SYSTEM_DEVICE, 10, {1, 3, 6, 1, 2, 1, 25, 3, 2, 1}},
	{SNMP_SYSTEM_LOGICAL_STORAGE, 10, {1, 3, 6, 1, 2, 1, 25, 2, 3, 1}},
	{SNMP_SYSTEM_SERVICE, 11, {1, 3, 6, 1, 4, 1, 77, 1, 2, 3, 1}},
	{SNMP_NETWORK_ARP, 9, {1, 3, 6, 1, 2, 1, 4, 22, 1}},
	{SNMP_NETWORK_ROUTES, 9, {1, 3, 6, 1, 2, 1, 4, 21, 1}},
	{SNMP_NETWORK_INTERFACES_BASIC, 9, {1, 3, 6, 1, 2, 1, 2, 2, 1}},
	{SNMP_NETWORK_TCPIP_TCP_CONNECTIONS, 9, {1, 3, 6, 1, 2, 1, 6, 13, 1}},
	{SNMP_NETWORK_TCPIP_UDP_SERVICES, 9, {1, 3, 6, 1, 2, 1, 7, 5, 1}},
	{SNMP_SOFTWARE, 10, {1, 3, 6, 1, 2, 1, 25, 4, 2, 1}},
	{SNMP_BRIDGE_FORWARDING_DATABASE, 10, {1, 3, 6, 1, 2, 1, 17, 4, 3, 1}},
	{SNMP_BRIDGE_STATIC_DATABASE, 10, {1, 3, 6, 1, 2, 1, 17, 5, 1, 1}}
};


struct Struct_Objet_Snmp Liste_Objet_Snmp[] = {

	{SNMP_SYSTEM_NAME, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 1, 5}},
	{SNMP_DESCRIPTION, 8, CHAINE_MAX, {1, 3, 6, 1, 2, 1, 1, 1}},
	{SNMP_CONTACT, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 1, 4}},
	{SNMP_LOCATION, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 1, 6}},
	{SNMP_UPTIME, 9, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 25, 1, 1}},
	{SNMP_RAM, 9, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 25, 2, 2}},

	{SNMP_IP_FORWARDING, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 1}},
	{SNMP_DEFAULT_TTL, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 2}},
	{SNMP_REASSEMBLY_TIMEOUT, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 13}},
	{SNMP_NEEDED_TO_BE_REASSEMBLED, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 14}},
	{SNMP_REASSEMBLED, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 15}},
	{SNMP_REASSEMBLY_FAILURES, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 16}},
	{SNMP_SUCCESSFULLY_FRAGMENTED, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 17}},
	{SNMP_FRAGMENTATION_FAILURES, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 18}},
	{SNMP_CREATED_FRAGMENTS, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 19}},
	{SNMP_DISCARDED_ROUTING_ENTRIES, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 23}},

	{SNMP_ALL, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 3}},
	{SNMP_FORWARDED, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 6}},
	{SNMP_DELIVERED, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 9}},
	{SNMP_HEADER_ERRORS, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 4}},
	{SNMP_ADDRESS_ERRORS, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 5}},
	{SNMP_UNKNOWN_PROTOCOLS, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 7}},
	{SNMP_INPUT_BUFFER_ERRORS, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 8}},

	{SNMP_REQUESTED, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 10}},
	{SNMP_OUTPUT_BUFFER_ERRORS, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 11}},
	{SNMP_NOT_ROUTED, 8, CHAINE_NORMALE, {1, 3, 6, 1, 2, 1, 4, 12}}
};


gboolean Demande_Snmp (struct Struct_Liste_Equipement *Equipement, gint Id_Snmp)
{
	netsnmp_session session, *ss;
	netsnmp_pdu *pdu, *response;
	netsnmp_variable_list *vars;
	size_t    rootlen;
	int       status;
	gchar     Texte[SPRINT_MAX_LEN], *Debut_Info;


	ERROR_if (Equipement == NULL);
	sem_wait (&Semaphore_Snmp);
	Debut_Info = NULL;
	debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Debut");
	SOCK_STARTUP;
	snmp_sess_init (&session);

	session.version = SNMP_VERSION_1;
	session.peername = Equipement->Adresse_Ip_Char;
	session.remote_port = SNMP_PORT;
	session.timeout = TIME_OUT_SNMP;
	session.community = Info_Demarrage.Communaute_Snmp;//"public";
	session.community_len = strlen (session.community);
	debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Open Session %s  Id_Snmp %d", Equipement->Adresse_Ip_Char, Id_Snmp);
	ss = snmp_open (&session);
	if (ss == NULL) {
		debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Failed : Open session");
		SOCK_CLEANUP;
		sem_post (&Semaphore_Snmp);
		return FALSE;
	}
	debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Envoie request %s  Id_Snmp %d", Equipement->Adresse_Ip_Char, Id_Snmp);
	pdu = snmp_pdu_create (SNMP_MSG_GETNEXT);
	snmp_add_null_var (pdu, Liste_Objet_Snmp[Id_Snmp].objid_mib, Liste_Objet_Snmp[Id_Snmp].Taille_oid);
	rootlen = Liste_Objet_Snmp[Id_Snmp].Taille_oid;
	debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Reception request %s  Id_Snmp %d", Equipement->Adresse_Ip_Char, Id_Snmp);
	status = snmp_synch_response (ss, pdu, &response);
	debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "status  : %li %s  Id_Snmp %d", status, Equipement->Adresse_Ip_Char, Id_Snmp);
	if (status == STAT_SUCCESS) {
		debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "OK  : %li %s  Id_Snmp %d ", response->errstat, Equipement->Adresse_Ip_Char, Id_Snmp);
		if (response->errstat == SNMP_ERR_NOERROR) {
			vars = response->variables;
			if ((vars->name_length < rootlen) || (memcmp (Liste_Objet_Snmp[Id_Snmp].objid_mib, vars->name, rootlen * sizeof (oid)) != 0)) {
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s  Id_Snmp %d (vars->name_length < rootlen) || (memcmp (Liste_Objet_Snmp[Id_Snmp].objid_mib, vars->name, rootlen * sizeof (oid)) != 0)", Equipement->Adresse_Ip_Char, Id_Snmp);
				if (response)
					snmp_free_pdu (response);
				snmp_close (ss);
				SOCK_CLEANUP;
				sem_post (&Semaphore_Snmp);
				return FALSE;
			}
			snprint_variable (Texte, sizeof (Texte), vars->name, vars->name_length, vars);
			ERROR_if (Texte == NULL);
			ERROR_if (strlen (Texte) >= SPRINT_MAX_LEN);
			debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Snmp :[%s] (%d)[%s]", session.peername, strlen (Texte), Texte);

			Debut_Info = index (Texte, '=');    
			ERROR_if (Debut_Info == NULL);
			ERROR_if (strlen (Debut_Info) == 0);
			if (Debut_Info != NULL)
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Retour Snmp : (%d)[%s]", strlen (Debut_Info), Debut_Info);
			else
				debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "[%s][%s]", session.peername, Texte);
		}
		else {
			Debut_Info = "None";
			if (response->errstat == SNMP_ERR_NOSUCHNAME)
				debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "[%s]End of MIB", session.peername);
			else
				debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "[%s]Error in packet. Reason: %s", session.peername, snmp_errstring (response->errstat));
		}
	
		if (response)
			snmp_free_pdu (response);
		snmp_close (ss);
		SOCK_CLEANUP;

		switch (Id_Snmp) {
		    case SNMP_SYSTEM_NAME:
			    Traitement_Chaine_Snmp (SNMP_SYSTEM_NAME, Debut_Info, Equipement->Snmp.System_Name);
			    break;
		    case SNMP_DESCRIPTION:
			    Traitement_Chaine_Snmp (SNMP_DESCRIPTION, Debut_Info, Equipement->Snmp.Description);
			    break;
		    case SNMP_CONTACT:
			    Traitement_Chaine_Snmp (SNMP_CONTACT, Debut_Info, Equipement->Snmp.Contact);
			    break;
		    case SNMP_LOCATION:
			    Traitement_Chaine_Snmp (SNMP_LOCATION, Debut_Info, Equipement->Snmp.Location);
			    break;
		    case SNMP_UPTIME:
			    Traitement_Timeticks_Snmp (SNMP_UPTIME, Debut_Info, Equipement->Snmp.Uptime);
			    break;
		    case SNMP_RAM:
			    Equipement->Snmp.Ram = Traitement_Integer_Snmp (SNMP_RAM, Debut_Info);
			    break;
		    case SNMP_IP_FORWARDING:
			    Traitement_Integer_Conv_Chaine_Snmp (SNMP_IP_FORWARDING, Debut_Info, Equipement->Snmp.Ip_Forwarding);
			    break;
		    case SNMP_DEFAULT_TTL:
			    Equipement->Snmp.Default_TTL = Traitement_Integer_Snmp (SNMP_DEFAULT_TTL, Debut_Info);
			    break;
		    case SNMP_REASSEMBLY_TIMEOUT:
			    Equipement->Snmp.Reassembly_Timeout = Traitement_Integer_Snmp (SNMP_REASSEMBLY_TIMEOUT, Debut_Info);
			    break;
		    case SNMP_NEEDED_TO_BE_REASSEMBLED:
			    Equipement->Snmp.Need_To_Be_Reassembled = Traitement_Counter_Snmp (SNMP_NEEDED_TO_BE_REASSEMBLED, Debut_Info);
			    break;
		    case SNMP_REASSEMBLED:
			    Equipement->Snmp.Reassembled = Traitement_Counter_Snmp (SNMP_REASSEMBLED, Debut_Info);
			    break;
		    case SNMP_REASSEMBLY_FAILURES:
			    Equipement->Snmp.Reassembly_Failures = Traitement_Counter_Snmp (SNMP_REASSEMBLY_FAILURES, Debut_Info);
			    break;
		    case SNMP_SUCCESSFULLY_FRAGMENTED:
			    Equipement->Snmp.Successfully_Fragmented = Traitement_Counter_Snmp (SNMP_SUCCESSFULLY_FRAGMENTED, Debut_Info);
			    break;
		    case SNMP_FRAGMENTATION_FAILURES:
			    Equipement->Snmp.Fragmentation_Failures = Traitement_Counter_Snmp (SNMP_FRAGMENTATION_FAILURES, Debut_Info);
			    break;
		    case SNMP_CREATED_FRAGMENTS:
			    Equipement->Snmp.Created_Fragments = Traitement_Counter_Snmp (SNMP_CREATED_FRAGMENTS, Debut_Info);
			    break;
		    case SNMP_DISCARDED_ROUTING_ENTRIES:
			    Equipement->Snmp.Discarded_Routing_Entries = Traitement_Counter_Snmp (SNMP_DISCARDED_ROUTING_ENTRIES, Debut_Info);
			    break;
		    case SNMP_ALL:
			    Equipement->Snmp.All = Traitement_Counter_Snmp (SNMP_ALL, Debut_Info);
			    break;
		    case SNMP_FORWARDED:
			    Equipement->Snmp.Forwarded = Traitement_Counter_Snmp (SNMP_FORWARDED, Debut_Info);
			    break;
		    case SNMP_DELIVERED:
			    Equipement->Snmp.Delivered = Traitement_Counter_Snmp (SNMP_DELIVERED, Debut_Info);
			    break;
		    case SNMP_HEADER_ERRORS:
			    Equipement->Snmp.Header_Errors = Traitement_Counter_Snmp (SNMP_HEADER_ERRORS, Debut_Info);
			    break;
		    case SNMP_ADDRESS_ERRORS:
			    Equipement->Snmp.Address_Errors = Traitement_Counter_Snmp (SNMP_ADDRESS_ERRORS, Debut_Info);
			    break;
		    case SNMP_UNKNOWN_PROTOCOLS:
			    Equipement->Snmp.Unknown_Protocol = Traitement_Counter_Snmp (SNMP_UNKNOWN_PROTOCOLS, Debut_Info);
			    break;
		    case SNMP_INPUT_BUFFER_ERRORS:
			    Equipement->Snmp.Input_Buffer_Errors = Traitement_Counter_Snmp (SNMP_INPUT_BUFFER_ERRORS, Debut_Info);
			    break;
		    case SNMP_REQUESTED:
			    Equipement->Snmp.Requested = Traitement_Counter_Snmp (SNMP_REQUESTED, Debut_Info);
			    break;
		    case SNMP_OUTPUT_BUFFER_ERRORS:
			    Equipement->Snmp.Output_Buffer_Errors = Traitement_Counter_Snmp (SNMP_OUTPUT_BUFFER_ERRORS, Debut_Info);
			    break;
		    case SNMP_NOT_ROUTED:
			    Equipement->Snmp.Not_Routed = Traitement_Counter_Snmp (SNMP_NOT_ROUTED, Debut_Info);
			    break;
		    default:
			    debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Id_Snmp (%d) inconnu ", Id_Snmp);
		}
		debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Fin request %s  Id_Snmp %d", Equipement->Adresse_Ip_Char, Id_Snmp);
		sem_post (&Semaphore_Snmp);
		return TRUE;
	}
	else {
	
		if (status == STAT_TIMEOUT)
			debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Timeout: No Response from %s", session.peername);
		else
			debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "[%s]ERROR", session.peername);
	
		if (response)
			snmp_free_pdu (response);
		snmp_close (ss);
		SOCK_CLEANUP;
		sem_post (&Semaphore_Snmp);
		return FALSE;
	}
	return FALSE;
}








void Traitement_Chaine_Snmp (gint Id_Snmp, gchar * Chaine_Brut, gchar * Stock)
{
#define   DEBUT_STRING  "= STRING: "
	gint      Taille;

	if (Chaine_Brut == NULL)
		return;
	if (strncmp (Chaine_Brut, DEBUT_STRING, (sizeof (DEBUT_STRING) - 1)) == 0) {
		Taille = strlen (Chaine_Brut + sizeof (DEBUT_STRING) - 1);
	
		if (Taille <= 0) {
			Stock = NULL;
			return;
		}
		if (Taille > (Liste_Objet_Snmp[Id_Snmp].Taille_Chaine_Max - 1))
			Taille = Liste_Objet_Snmp[Id_Snmp].Taille_Chaine_Max - 1;
		strncpy (Stock, Chaine_Brut + sizeof (DEBUT_STRING) - 1, Taille);
		Stock[Taille] = 0;
	
	}
}

void Traitement_Timeticks_Snmp (gint Id_Snmp, gchar * Chaine_Brut, gchar * Stock)
{
#define   DEBUT_TIMETICKS  "= Timeticks: "
	gint      Taille;

	if (Chaine_Brut == NULL)
		return;
	if (strncmp (Chaine_Brut, DEBUT_TIMETICKS, (sizeof (DEBUT_TIMETICKS) - 1)) == 0) {
		Taille = strlen (Chaine_Brut + sizeof (DEBUT_TIMETICKS) - 1);
	
		if (Taille <= 0) {
			Stock = NULL;
			return;
		}
		if (Taille > (Liste_Objet_Snmp[Id_Snmp].Taille_Chaine_Max - 1))
			Taille = Liste_Objet_Snmp[Id_Snmp].Taille_Chaine_Max - 1;
		strncpy (Stock, Chaine_Brut + sizeof (DEBUT_TIMETICKS) - 1, Taille);
		Stock[Taille] = 0;
	
	}
}


gint Traitement_Counter_Snmp (gint Id_Snmp, gchar * Chaine_Brut)
{
#define   DEBUT_COUNTER  "= Counter32: "
	gint      Nb;

	if (Chaine_Brut == NULL)
		return -1;

	if (strncmp (Chaine_Brut, DEBUT_COUNTER, (sizeof (DEBUT_COUNTER) - 1)) == 0) {
		if (sscanf (Chaine_Brut, "= Counter32: %i", &Nb) != 1)
			return -1;
	
		return Nb;
	}
	return -1;
}


void Traitement_Integer_Conv_Chaine_Snmp (gint Id_Snmp, gchar * Chaine_Brut, gchar * Stock)
{
#define   DEBUT_INTEGER  "= INTEGER: "
	gint      Taille;

	if (Chaine_Brut == NULL)
		return;
	if (strncmp (Chaine_Brut, DEBUT_INTEGER, (sizeof (DEBUT_INTEGER) - 1)) == 0) {
		Taille = strlen (Chaine_Brut + sizeof (DEBUT_INTEGER) - 1);
	
		if (Taille <= 0) {
			Stock = NULL;
			return;
		}
		if (Taille > (Liste_Objet_Snmp[Id_Snmp].Taille_Chaine_Max - 1))
			Taille = Liste_Objet_Snmp[Id_Snmp].Taille_Chaine_Max - 1;
		strncpy (Stock, Chaine_Brut + sizeof (DEBUT_INTEGER) - 1, Taille);
		Stock[Taille] = 0;
	
	}
}


gint Traitement_Integer_Snmp (gint Id_Snmp, gchar * Chaine_Brut)
{
#define   DEBUT_INTEGER  "= INTEGER: "
	gint      Nb;

	if (Chaine_Brut == NULL)
		return -1;

	if (strncmp (Chaine_Brut, DEBUT_INTEGER, (sizeof (DEBUT_INTEGER) - 1)) == 0) {
		if (sscanf (Chaine_Brut, "= INTEGER: %d", &Nb) != 1)
			return -1;
	
		return Nb;
	}
	return -1;
}




void Demande_Snmp_Equipement (struct Struct_Liste_Equipement *Equipement)
{
	gint      i;

	ERROR_if (Equipement == NULL);
	debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Debut Demande_Snmp_Equipement : %s\n", Equipement->Adresse_Ip_Char);
	if (Demande_Snmp (Equipement, SNMP_SYSTEM_NAME)) {
		Equipement->Snmp_Ouvert = TRUE;
		for (i = 1; i < NB_TOTAL_ID_SNMP_SCALAIRE; i++)
			Demande_Snmp (Equipement, i);

	
		/* printf ("Description = [%s]\n", Equipement->Snmp.Description);
		 * printf ("Contact = [%s]\n", Equipement->Snmp.Contact);
		 * printf ("Location = [%s]\n", Equipement->Snmp.Location);
		 * printf ("Uptime = [%s]\n", Equipement->Snmp.Uptime);
		 * printf ("Ram = [%d]\n", Equipement->Snmp.Ram);
		 * printf ("Ip_Forwarding = [%d]\n", Equipement->Snmp.Ip_Forwarding);
		 * printf ("Default_TTL = [%d]\n", Equipement->Snmp.Default_TTL);
		 * printf ("Reassembly_Timeout = [%d]\n", Equipement->Snmp.Reassembly_Timeout);
		 * printf ("Need_To_Be_Reassembled = [%d]\n", Equipement->Snmp.Need_To_Be_Reassembled);
		 * printf ("Reassembled = [%d]\n", Equipement->Snmp.Reassembled);
		 * printf ("Reassembly_Failures = [%d]\n", Equipement->Snmp.Reassembly_Failures);
		 * printf ("Successfully_Fragmented = [%d]\n", Equipement->Snmp.Successfully_Fragmented);
		 * printf ("Fragmentation_Failures = [%d]\n", Equipement->Snmp.Fragmentation_Failures);
		 * printf ("Created_Fragments = [%d]\n", Equipement->Snmp.Created_Fragments);
		 * printf ("Discarded_Routing_Entries = [%d]\n", Equipement->Snmp.Discarded_Routing_Entries);
		 * printf ("All = [%d]\n", Equipement->Snmp.All);
		 * printf ("Forwarded = [%d]\n", Equipement->Snmp.Forwarded);
		 * printf ("Delivered = [%d]\n", Equipement->Snmp.Delivered);
		 * printf ("Header_Errors = [%d]\n", Equipement->Snmp.Header_Errors);
		 * printf ("Address_Errors = [%d]\n", Equipement->Snmp.Address_Errors);
		 * printf ("Unknown_Protocol = [%d]\n", Equipement->Snmp.Unknown_Protocol);
		 * printf ("Input_Buffer_Errors = [%d]\n", Equipement->Snmp.Input_Buffer_Errors);
		 * printf ("Requested = [%d]\n", Equipement->Snmp.Requested);
		 * printf ("Output_Buffer_Errors = [%d]\n", Equipement->Snmp.Output_Buffer_Errors);
		 * printf ("Not_Routed = [%d]\n", Equipement->Snmp.Not_Routed); */

	}
	debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Fin Demande_Snmp_Equipement : %s\n", Equipement->Adresse_Ip_Char);

}

#define HOST_RESSOURCE "HOST-RESOURCES-TYPES::"
void Envoie_Snmp_Liste (struct Struct_Liste_Equipement *Equipement, gint Id_Snmp)
{
	netsnmp_session session, *ss;
	netsnmp_pdu *pdu, *response;
	netsnmp_variable_list *vars;
	oid       name[MAX_OID_LEN];
	size_t    name_length;
	oid       root[MAX_OID_LEN];
	size_t    rootlen;
	gint      status, IndexTableau, Taille, ligne, Ancienne_Colonne;
	gboolean  Fin, Donnee_Presente;
	gchar     Texte[SPRINT_MAX_LEN], *Debut_Info;
	struct struct_Retour_Liste_SNMP Message;

	ERROR_if (Equipement == NULL);
	sem_wait (&Semaphore_Snmp);
	bzero (&Message, sizeof (struct struct_Retour_Liste_SNMP));

	Message.ID_Reseau = Info_Demarrage.ID_Reseau;
	memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
	Message.ID_Snmp = Id_Snmp;
	IndexTableau = 0;

	SOCK_STARTUP;
	bzero (&session, sizeof (netsnmp_session));
	snmp_sess_init (&session);

	session.version = SNMP_VERSION_1;
	session.peername = Equipement->Adresse_Ip_Char;
	session.remote_port = SNMP_PORT;
	session.timeout = TIME_OUT_SNMP;
	session.community = Info_Demarrage.Communaute_Snmp;//"public";
	session.community_len = strlen (session.community);

	ss = snmp_open (&session);
	if (ss == NULL) {
		debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Failed : Open session");
		SOCK_CLEANUP;
		sem_post (&Semaphore_Snmp);
		return;
	}
	memmove (root, Liste_Snmp[Id_Snmp].objid_mib, Liste_Snmp[Id_Snmp].Taille_oid * sizeof (oid));
	rootlen = Liste_Snmp[Id_Snmp].Taille_oid;
	memmove (name, root, rootlen * sizeof (oid));
	name_length = rootlen;
	Ancienne_Colonne = 0;
	ligne = 0;
	Donnee_Presente = FALSE;
	Fin = FALSE;
	while (!Fin) {
		pdu = snmp_pdu_create (SNMP_MSG_GETNEXT);
		snmp_add_null_var (pdu, name, name_length);

		status = snmp_synch_response (ss, pdu, &response);
		if (status == STAT_SUCCESS) {
			if (response->errstat == SNMP_ERR_NOERROR) {

				vars = response->variables;
				if ((vars->name_length < rootlen) || (memcmp (root, vars->name, rootlen * sizeof (oid)) != 0)) {
					Fin = TRUE;
					if (response)
						snmp_free_pdu (response);
					continue;
				}

				snprint_variable (Texte, sizeof (Texte), vars->name, vars->name_length, vars);
				Debut_Info = strstr (Texte, " = ");
				if (Debut_Info == NULL) {
					Fin = TRUE;
					if (response)
						snmp_free_pdu (response);
					continue;
				}
				Debut_Info = Debut_Info + strlen (" = ");
				if (index (Debut_Info, ':') != NULL)
					Debut_Info = index (Debut_Info, ':') + 2;
				if (strncmp (Debut_Info, HOST_RESSOURCE, strlen (HOST_RESSOURCE)) == 0)
					Debut_Info = Debut_Info + strlen (HOST_RESSOURCE);
			
				Message.Liste_Donnee[IndexTableau].Colonne = (gint) vars->name[rootlen];
				if (Ancienne_Colonne != (gint) vars->name[rootlen]) {
					Ancienne_Colonne = (gint) vars->name[rootlen];
					ligne = 0;
				}
				Message.Liste_Donnee[IndexTableau].Ligne = ligne;
				ligne++;
				Taille = strlen (Debut_Info);
				if (Taille > CHAINE_NORMALE - 1)
					Taille = CHAINE_NORMALE - 1;
				strncpy (Message.Liste_Donnee[IndexTableau].Info, Debut_Info, Taille);
				Message.Liste_Donnee[IndexTableau].Info[Taille] = 0;
				Donnee_Presente = TRUE;
				IndexTableau++;
				if (IndexTableau == NB_MAX_LIGNE_LISTE_SNMP) {
					Message.Tout_Donnee_Transferer = FALSE;
					Communication_Envoie_Donnee (RETOUR_LISTE_SNMP, (gpointer *) & Message, sizeof (Message));
					bzero (&Message, sizeof (struct struct_Retour_Liste_SNMP));
				
					Message.ID_Reseau = Info_Demarrage.ID_Reseau;
					memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
					Message.ID_Snmp = Id_Snmp;
					IndexTableau = 0;
					Donnee_Presente = FALSE;
				}

				if ((vars->type != SNMP_ENDOFMIBVIEW) && (vars->type != SNMP_NOSUCHOBJECT) && (vars->type != SNMP_NOSUCHINSTANCE)) {
					memmove ((char *) name, (char *) vars->name, vars->name_length * sizeof (oid));
					name_length = vars->name_length;
				}
				else
					Fin = TRUE;

			}
			else {
				if (response->errstat == SNMP_ERR_NOSUCHNAME) {
					debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "[%s]End of MIB", session.peername);
					if (response)
						snmp_free_pdu (response);
					snmp_close (ss);
					SOCK_CLEANUP;
					sem_post (&Semaphore_Snmp);
					return;
				}
				else {
					debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "[%s]Error in packet. Reason: %s", session.peername, snmp_errstring (response->errstat));
					if (response)
						snmp_free_pdu (response);
					snmp_close (ss);
					SOCK_CLEANUP;
					sem_post (&Semaphore_Snmp);
					return;
				}
			}
		}
		else {
			if (status == STAT_TIMEOUT) {
				debug_printf (D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Timeout: No Response from %s", session.peername);
				if (response)
					snmp_free_pdu (response);
				snmp_close (ss);
				SOCK_CLEANUP;
				sem_post (&Semaphore_Snmp);
				return;
			}
			else {
				debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "[%s]ERROR", session.peername);
				if (response)
					snmp_free_pdu (response);
				snmp_close (ss);
				SOCK_CLEANUP;
				sem_post (&Semaphore_Snmp);
				return;
			}
		}
		if (response)
			snmp_free_pdu (response);

	}
	snmp_close (ss);
	SOCK_CLEANUP;

	Message.Tout_Donnee_Transferer = TRUE;
	if (Donnee_Presente)
		Communication_Envoie_Donnee (RETOUR_LISTE_SNMP, (gpointer *) & Message, sizeof (Message));
	sem_post (&Semaphore_Snmp);
}



void Initialisation_Snmp (void)
{
	init_snmp ("AutoScan_Agent");
}


#endif
