/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <semaphore.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include "Socket.h"
#include "Semaphore.h"
#include "Debug.h"

int socket_control (int domain, int type, int protocol)
{
	int       Socket;

	if ((Socket = socket (domain, type, protocol)) != -1) {
		sem_wait (&Semaphore_Control_Usage_Socket);
		Nb_Socket_Ouverte++;
		sem_post (&Semaphore_Control_Usage_Socket);
	}
	return Socket;
}


int close_control (int fd)
{
	int       close_s;

	if ((close_s = close (fd)) != -1) {
		sem_wait (&Semaphore_Control_Usage_Socket);
		Nb_Socket_Ouverte--;
		sem_post (&Semaphore_Control_Usage_Socket);
	}
	return close_s;
}


int close_Shutdown_control (FILE     *In)
{
	int       close_s;

	if ((close_s = shutdown(fileno(In),SHUT_RDWR)) != -1) {
		sem_wait (&Semaphore_Control_Usage_Socket);
		Nb_Socket_Ouverte--;
		sem_post (&Semaphore_Control_Usage_Socket);
	}
	else
		debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%d", close_s);

	return close_s;
}
